Index: src/common/weeconfig.c
===================================================================
RCS file: /sources/weechat/weechat/src/common/weeconfig.c,v
retrieving revision 1.147
diff -u -d -p -B -r1.147 weeconfig.c
--- src/common/weeconfig.c	12 Feb 2007 17:39:35 -0000	1.147
+++ src/common/weeconfig.c	23 Mar 2007 11:17:01 -0000
@@ -815,60 +816,59 @@ t_config_option weechat_options_dcc[] =
 { { "dcc_auto_accept_files", N_("automatically accept dcc files"),
     N_("automatically accept incoming dcc files"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &cfg_dcc_auto_accept_files, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_auto_accept_files, NULL, -1, &config_change_noop },
   { "dcc_auto_accept_chats", N_("automatically accept dcc chats"),
     N_("automatically accept dcc chats (use carefully!)"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &cfg_dcc_auto_accept_chats, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_auto_accept_chats, NULL, -1, &config_change_noop },
   { "dcc_timeout", N_("timeout for dcc request"),
     N_("timeout for dcc request (in seconds)"),
     OPTION_TYPE_INT, 5, INT_MAX, 300,
-    NULL, NULL, &cfg_dcc_timeout, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_timeout, NULL, -1, &config_change_noop },
   { "dcc_blocksize", N_("block size for dcc packets"),
     N_("block size for dcc packets in bytes (default: 65536)"),
     OPTION_TYPE_INT, DCC_MIN_BLOCKSIZE, DCC_MAX_BLOCKSIZE, 65536,
-    NULL, NULL, &cfg_dcc_blocksize, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_blocksize, NULL, -1, &config_change_noop },
   { "dcc_fast_send", N_("does not wait for ACK when sending file"),
     N_("does not wait for ACK when sending file"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &cfg_dcc_fast_send, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_fast_send, NULL, -1, &config_change_noop },
   { "dcc_port_range", N_("allowed ports for outgoing dcc"),
     N_("restricts outgoing dcc to use only ports in the given range "
        "(useful for NAT) (syntax: a single port, ie. 5000 or a port "
        "range, ie. 5000-5015, empty value means any port)"),
     OPTION_TYPE_STRING, 0, 0, 0, "",
-    NULL, NULL, &cfg_dcc_port_range, &config_change_noop },
+    NULL, NULL, &cfg_dcc_port_range, -1, &config_change_noop },
   { "dcc_own_ip", N_("IP address for outgoing dcc"),
     N_("IP or DNS address used for outgoing dcc "
        "(if empty, local interface IP is used)"),
     OPTION_TYPE_STRING, 0, 0, 0, "",
-    NULL, NULL, &cfg_dcc_own_ip, &config_change_noop },
+    NULL, NULL, &cfg_dcc_own_ip, -1, &config_change_noop },
   { "dcc_download_path", N_("path for incoming files with dcc"),
     N_("path for writing incoming files with dcc (default: user home)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "%h/dcc", NULL, NULL, &cfg_dcc_download_path, &config_change_noop },
+    "%h/dcc", NULL, NULL, &cfg_dcc_download_path, -1, &config_change_noop },
   { "dcc_upload_path", N_("default path for sending files with dcc"),
     N_("path for reading files when sending thru dcc (when no path is specified)"),
     OPTION_TYPE_STRING, 0, 0, 0, "~",
-    NULL, NULL, &cfg_dcc_upload_path, &config_change_noop },
+    NULL, NULL, &cfg_dcc_upload_path, -1, &config_change_noop },
   { "dcc_convert_spaces", N_("convert spaces to underscores when sending files"),
     N_("convert spaces to underscores when sending files"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &cfg_dcc_convert_spaces, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_convert_spaces, NULL, -1, &config_change_noop },
   { "dcc_auto_rename", N_("automatically rename dcc files if already exists"),
     N_("rename incoming files if already exists (add '.1', '.2', ...)"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &cfg_dcc_auto_rename, NULL, &config_change_noop },
+    NULL, NULL, &cfg_dcc_auto_rename, NULL, -1, &config_change_noop },
   { "dcc_auto_resume", N_("automatically resume aborted transfers"),
     N_("automatically resume dcc transfer if connection with remote host is loosed"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &cfg_dcc_auto_resume, NULL, &config_change_noop },
-  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL }
+    NULL, NULL, &cfg_dcc_auto_resume, NULL, -1, &config_change_noop },
+  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, -1, NULL }
 };
 
 /* config, proxy section */
 
-int cfg_proxy_use;
 int cfg_proxy_type;
 int cfg_proxy_ipv6;
 char *cfg_proxy_type_values[] =
@@ -879,35 +879,31 @@ char *cfg_proxy_username;
 char *cfg_proxy_password;
 
 t_config_option weechat_options_proxy[] =
-{ { "proxy_use", N_("use proxy"),
-    N_("use a proxy server to connect to irc server"),
-    OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &cfg_proxy_use, NULL, &config_change_noop },
-  { "proxy_type", N_("proxy type"),
+{ { "proxy_type", N_("proxy type"),
     N_("proxy type (http (default), socks4, socks5)"),
     OPTION_TYPE_INT_WITH_STRING, 0, 0, 0,
-    "http", cfg_proxy_type_values, &cfg_proxy_type, NULL, &config_change_noop },
+    "http", cfg_proxy_type_values, &cfg_proxy_type, NULL, -1, &config_change_noop },
   { "proxy_ipv6", N_("use ipv6 proxy"),
     N_("connect to proxy in ipv6"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &cfg_proxy_ipv6, NULL, &config_change_noop },
+    NULL, NULL, &cfg_proxy_ipv6, NULL, -1, &config_change_noop },
   { "proxy_address", N_("proxy address"),
     N_("proxy server address (IP or hostname)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &cfg_proxy_address, &config_change_noop },
+    "", NULL, NULL, &cfg_proxy_address, -1, &config_change_noop },
   { "proxy_port", N_("port for proxy"),
     N_("port for connecting to proxy server"),
     OPTION_TYPE_INT, 0, 65535, 3128,
-    NULL, NULL, &cfg_proxy_port, NULL, &config_change_noop },
+    NULL, NULL, &cfg_proxy_port, NULL, -1, &config_change_noop },
   { "proxy_username", N_("proxy username"),
     N_("username for proxy server"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &cfg_proxy_username, &config_change_noop },
+    "", NULL, NULL, &cfg_proxy_username, -1, &config_change_noop },
   { "proxy_password", N_("proxy password"),
     N_("password for proxy server"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &cfg_proxy_password, &config_change_noop },
-  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL }
+    "", NULL, NULL, &cfg_proxy_password, -1, &config_change_noop },
+  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, -1, NULL }
 };
 
 /* config, plugins section */
@@ -921,13 +917,13 @@ t_config_option weechat_options_plugins[
     N_("path for searching plugins ('%h' will be replaced by WeeChat home, "
        "~/.weechat by default)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "%h/plugins", NULL, NULL, &cfg_plugins_path, &config_change_noop },
+    "%h/plugins", NULL, NULL, &cfg_plugins_path, -1, &config_change_noop },
   { "plugins_autoload", N_("list of plugins to load automatically"),
     N_("comma separated list of plugins to load automatically at startup, "
        "\"*\" means all plugins found "
        "(names may be partial, for example \"perl\" is ok for \"libperl.so\")"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "*", NULL, NULL, &cfg_plugins_autoload, &config_change_noop },
+    "*", NULL, NULL, &cfg_plugins_autoload, -1, &config_change_noop },
   { "plugins_extension", N_("standard plugins extension in filename"),
     N_("standard plugins extension in filename, used for autoload "
        "(if empty, then all files are loaded when autoload is \"*\")"),
@@ -937,109 +933,126 @@ t_config_option weechat_options_plugins[
 #else
     ".so",
 #endif
-    NULL, NULL, &cfg_plugins_extension, &config_change_noop },
-  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL }
+    NULL, NULL, &cfg_plugins_extension, -1, &config_change_noop },
+  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, -1, NULL }
 };
 
 /* config, server section */
 
+/* XXX: there is code, that relies that weechat_options_server
+ * point to cfg_server structure */
 static t_irc_server cfg_server;
 
 t_config_option weechat_options_server[] =
 { { "server_name", N_("server name"),
     N_("name associated to IRC server (for display only)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.name), NULL },
+    "", NULL, NULL, &(cfg_server.name), -1, NULL },
+  { "server_address", N_("server address or hostname"),
+    N_("IP address or hostname of IRC server"),
+    OPTION_TYPE_STRING, 0, 0, 0,
+    "", NULL, NULL, &(cfg_server.address), -1, NULL },
+  { "server_port", N_("port for IRC server"),
+    N_("port for connecting to server"),
+    OPTION_TYPE_INT, 0, 65535, 6667,
+    NULL, NULL, &(cfg_server.port), NULL, -1, NULL },
+  { "server_password", N_("server password"),
+    N_("password for IRC server"),
+    OPTION_TYPE_STRING, 0, 0, 0,
+    "", NULL, NULL, &(cfg_server.password), -1, NULL },
+  { "server_autojoin", N_("list of channels to join when connected to server"),
+    N_("comma separated list of channels to join when connected to server (example: \"#chan1,#chan2,#chan3 key1,key2\")"),
+    OPTION_TYPE_STRING, 0, 0, 0,
+    "", NULL, NULL, &(cfg_server.autojoin), -1, NULL },
+  { "server_command", N_("command(s) to run when connected to server"),
+    N_("command(s) to run when connected to server (many commands should be "
+       "separated by ';', use '\\;' for a semicolon, special variables $nick, "
+       "$channel and $server are replaced by their value)"),
+    OPTION_TYPE_STRING, 0, 0, 0,
+    "", NULL, NULL, &(cfg_server.command), -1, NULL },
+  { "server_notify_levels", N_("notify levels for channels of this server"),
+    N_("comma separated list of notify levels for channels of this server "
+       "(format: #channel:1,..), a channel name '*' is reserved for server "
+       "default notify level"),
+    OPTION_TYPE_STRING, 0, 0, 0,
+    "", NULL, NULL, &(cfg_server.notify_levels), -1, config_change_notify_levels },
+  /* options, that can have defaults, they are copied during initialization */
   { "server_autoconnect", N_("automatically connect to server"),
     N_("automatically connect to server when WeeChat is starting"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &(cfg_server.autoconnect), NULL, NULL },
+    NULL, NULL, &(cfg_server.setting.autoconnect), NULL, offsetof(t_irc_server, isset.autoconnect), NULL },
   { "server_autoreconnect", N_("automatically reconnect to server"),
     N_("automatically reconnect to server when disconnected"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &(cfg_server.autoreconnect), NULL, NULL },
+    NULL, NULL, &(cfg_server.setting.autoreconnect), NULL, offsetof(t_irc_server, isset.autoreconnect), NULL },
   { "server_autoreconnect_delay", N_("delay before trying again to reconnect"),
     N_("delay (in seconds) before trying again to reconnect to server"),
     OPTION_TYPE_INT, 0, 65535, 30,
-    NULL, NULL, &(cfg_server.autoreconnect_delay), NULL, NULL },
-  { "server_address", N_("server address or hostname"),
-    N_("IP address or hostname of IRC server"),
-    OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.address), NULL },
-  { "server_port", N_("port for IRC server"),
-    N_("port for connecting to server"),
-    OPTION_TYPE_INT, 0, 65535, 6667,
-    NULL, NULL, &(cfg_server.port), NULL, NULL },
+    NULL, NULL, &(cfg_server.setting.autoreconnect_delay), NULL, offsetof(t_irc_server, isset.autoreconnect_delay), NULL },
   { "server_ipv6", N_("use IPv6 protocol for server communication"),
     N_("use IPv6 protocol for server communication"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &(cfg_server.ipv6), NULL, NULL },
+    NULL, NULL, &(cfg_server.setting.ipv6), NULL, offsetof(t_irc_server, isset.ipv6), NULL },
   { "server_ssl", N_("use SSL for server communication"),
     N_("use SSL for server communication"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
-    NULL, NULL, &(cfg_server.ssl), NULL, NULL },
-  { "server_password", N_("server password"),
-    N_("password for IRC server"),
-    OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.password), NULL },
+    NULL, NULL, &(cfg_server.setting.ssl), NULL, offsetof(t_irc_server, isset.ssl), NULL },
   { "server_nick1", N_("nickname for server"),
     N_("nickname to use on IRC server"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.nick1), NULL },
+    "", NULL, NULL, &(cfg_server.setting.nick1), offsetof(t_irc_server, isset.nick1), NULL },
   { "server_nick2", N_("alternate nickname for server"),
     N_("alternate nickname to use on IRC server (if nickname is already used)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.nick2), NULL },
+    "", NULL, NULL, &(cfg_server.setting.nick2), offsetof(t_irc_server, isset.nick2), NULL },
   { "server_nick3", N_("2nd alternate nickname for server"),
     N_("2nd alternate nickname to use on IRC server (if alternate nickname is already used)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.nick3), NULL },
+    "", NULL, NULL, &(cfg_server.setting.nick3), offsetof(t_irc_server, isset.nick3), NULL },
   { "server_username", N_("user name for server"),
     N_("user name to use on IRC server"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.username), NULL },
+    "", NULL, NULL, &(cfg_server.setting.username), offsetof(t_irc_server, isset.username), NULL },
   { "server_realname", N_("real name for server"),
     N_("real name to use on IRC server"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.realname), NULL },
+    "", NULL, NULL, &(cfg_server.setting.realname), offsetof(t_irc_server, isset.realname), NULL },
   { "server_hostname", N_("custom hostname/IP for server"),
     N_("custom hostname/IP for server (optional, if empty local hostname is used)"),
     OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.hostname), NULL },
-  { "server_command", N_("command(s) to run when connected to server"),
-    N_("command(s) to run when connected to server (many commands should be "
-       "separated by ';', use '\\;' for a semicolon, special variables $nick, "
-       "$channel and $server are replaced by their value)"),
-    OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.command), NULL },
+    "", NULL, NULL, &(cfg_server.setting.hostname), offsetof(t_irc_server, isset.hostname), NULL },
   { "server_command_delay", N_("delay (in seconds) after command was executed"),
     N_("delay (in seconds) after command was executed (example: give some time for authentication)"),
     OPTION_TYPE_INT, 0, 5, 0,
-    NULL, NULL, &(cfg_server.command_delay), NULL, NULL },
-  { "server_autojoin", N_("list of channels to join when connected to server"),
-    N_("comma separated list of channels to join when connected to server (example: \"#chan1,#chan2,#chan3 key1,key2\")"),
-    OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.autojoin), NULL },
+    NULL, NULL, &(cfg_server.setting.command_delay), NULL, offsetof(t_irc_server, isset.command_delay), NULL },
   { "server_autorejoin", N_("automatically rejoin channels when kicked"),
     N_("automatically rejoin channels when kicked"),
     OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_TRUE,
-    NULL, NULL, &(cfg_server.autorejoin), NULL, NULL },
-  { "server_notify_levels", N_("notify levels for channels of this server"),
-    N_("comma separated list of notify levels for channels of this server "
-       "(format: #channel:1,..), a channel name '*' is reserved for server "
-       "default notify level"),
-    OPTION_TYPE_STRING, 0, 0, 0,
-    "", NULL, NULL, &(cfg_server.notify_levels), config_change_notify_levels },
-  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, NULL }
+    NULL, NULL, &(cfg_server.setting.autorejoin), NULL, offsetof(t_irc_server, isset.autorejoin), NULL },
+  { "server_proxy_use", N_("use proxy"),
+    N_("use a proxy server to connect to irc server"),
+    OPTION_TYPE_BOOLEAN, BOOL_FALSE, BOOL_TRUE, BOOL_FALSE,
+    NULL, NULL, &(cfg_server.setting.proxy_use), NULL, offsetof(t_irc_server, isset.proxy_use), NULL },
+  { NULL, NULL, NULL, 0, 0, 0, 0, NULL, NULL, NULL, NULL, -1, NULL }
 };
 
+/* config, server_defaults section */
+
+/* XXX: we don't maintain .isset. in server_defaults,
+ * weechat_options_server_defaults is initialized basing on 
+ * weechat_options_server later */
+t_irc_server server_defaults;
+
+t_config_option *weechat_options_server_defaults = NULL;
+
 /* all weechat options */
 
 t_config_option *weechat_options[CONFIG_NUMBER_SECTIONS] =
 { weechat_options_look, weechat_options_colors, weechat_options_history,
   weechat_options_log, weechat_options_irc, weechat_options_dcc,
   weechat_options_proxy, weechat_options_plugins, NULL, NULL, NULL,
-  weechat_options_server
+  weechat_options_server, 
+  NULL /* note, it's reinitialized later */
 };
 
 
@@ -1502,50 +1516,23 @@ config_option_list_get_value (char **str
  */
 
 void *
-config_get_server_option_ptr (t_irc_server *server, char *option_name)
+config_get_server_option_ptr (t_irc_server *server, const t_config_option *option)
 {
-    if (ascii_strcasecmp (option_name, "server_name") == 0)
-        return (void *)(&server->name);
-    if (ascii_strcasecmp (option_name, "server_autoconnect") == 0)
-        return (void *)(&server->autoconnect);
-    if (ascii_strcasecmp (option_name, "server_autoreconnect") == 0)
-        return (void *)(&server->autoreconnect);
-    if (ascii_strcasecmp (option_name, "server_autoreconnect_delay") == 0)
-        return (void *)(&server->autoreconnect_delay);
-    if (ascii_strcasecmp (option_name, "server_address") == 0)
-        return (void *)(&server->address);
-    if (ascii_strcasecmp (option_name, "server_port") == 0)
-        return (void *)(&server->port);
-    if (ascii_strcasecmp (option_name, "server_ipv6") == 0)
-        return (void *)(&server->ipv6);
-    if (ascii_strcasecmp (option_name, "server_ssl") == 0)
-        return (void *)(&server->ssl);
-    if (ascii_strcasecmp (option_name, "server_password") == 0)
-        return (void *)(&server->password);
-    if (ascii_strcasecmp (option_name, "server_nick1") == 0)
-        return (void *)(&server->nick1);
-    if (ascii_strcasecmp (option_name, "server_nick2") == 0)
-        return (void *)(&server->nick2);
-    if (ascii_strcasecmp (option_name, "server_nick3") == 0)
-        return (void *)(&server->nick3);
-    if (ascii_strcasecmp (option_name, "server_username") == 0)
-        return (void *)(&server->username);
-    if (ascii_strcasecmp (option_name, "server_realname") == 0)
-        return (void *)(&server->realname);
-    if (ascii_strcasecmp (option_name, "server_hostname") == 0)
-        return (void *)(&server->hostname);
-    if (ascii_strcasecmp (option_name, "server_command") == 0)
-        return (void *)(&server->command);
-    if (ascii_strcasecmp (option_name, "server_command_delay") == 0)
-        return (void *)(&server->command_delay);
-    if (ascii_strcasecmp (option_name, "server_autojoin") == 0)
-        return (void *)(&server->autojoin);
-    if (ascii_strcasecmp (option_name, "server_autorejoin") == 0)
-        return (void *)(&server->autorejoin);
-    if (ascii_strcasecmp (option_name, "server_notify_levels") == 0)
-        return (void *)(&server->notify_levels);
-    /* option not found */
-    return NULL;
+    /* small hack is better than big one */
+    char *pptr = NULL;
+    switch (option->option_type)
+    {
+        case OPTION_TYPE_BOOLEAN:
+        case OPTION_TYPE_INT:
+        case OPTION_TYPE_INT_WITH_STRING:
+        case OPTION_TYPE_COLOR:
+            pptr = (char*)option->ptr_int;
+            break;
+        case OPTION_TYPE_STRING:
+            pptr = (char*)option->ptr_string;
+            break;
+    }
+    return (void*)( (char*)server + (pptr - (char*)&cfg_server) );
 }
 
 /*
@@ -1564,10 +1551,6 @@ config_set_server_value (t_irc_server *s
     void *ptr_data;
     int int_value;
     
-    ptr_data = config_get_server_option_ptr (server, option_name);
-    if (!ptr_data)
-        return -1;
-    
     ptr_option = NULL;
     for (i = 0; weechat_options[CONFIG_SECTION_SERVER][i].option_name; i++)
     {
@@ -1580,6 +1563,10 @@ config_set_server_value (t_irc_server *s
     }
     if (!ptr_option)
         return -1;
+
+    ptr_data = config_get_server_option_ptr (server, ptr_option);
+    if (!ptr_data)
+        return -1;
     
     switch (ptr_option->option_type)
     {
@@ -1620,6 +1607,10 @@ config_set_server_value (t_irc_server *s
             *((char **)ptr_data) = strdup (value);
             break;
     }
+
+    if (ptr_option->offsetof_isset > 0)
+        *(int*)((char*)server + ptr_option->offsetof_isset) = value[0] ? 1 : 0;
+   
     if (ptr_option->handler_change != NULL)
         (void) (ptr_option->handler_change());
     return 0;
@@ -1687,7 +1678,7 @@ config_option_search_option_value (char 
                                 pos + 1) == 0)
                     {
                         ptr_option = &weechat_options[CONFIG_SECTION_SERVER][i];
-                        ptr_value = config_get_server_option_ptr (ptr_server, pos + 1);
+                        ptr_value = config_get_server_option_ptr (ptr_server, ptr_option);
                         break;
                     }
                 }
@@ -1746,12 +1737,7 @@ config_allocate_server (char *filename, 
 {
     if (!cfg_server.name
         || !cfg_server.address
-        || cfg_server.port < 0
-        || !cfg_server.nick1
-        || !cfg_server.nick2
-        || !cfg_server.nick3
-        || !cfg_server.username
-        || !cfg_server.realname)
+        || cfg_server.port < 0)
     {
         server_free_all ();
         gui_printf (NULL,
@@ -1768,15 +1754,7 @@ config_allocate_server (char *filename, 
                     WEECHAT_WARNING, filename, line_number, cfg_server.name);
         return 0;
     }
-    if (!server_new (cfg_server.name,
-                     cfg_server.autoconnect, cfg_server.autoreconnect,
-                     cfg_server.autoreconnect_delay, 0, cfg_server.address,
-                     cfg_server.port, cfg_server.ipv6, cfg_server.ssl,
-                     cfg_server.password, cfg_server.nick1, cfg_server.nick2,
-                     cfg_server.nick3, cfg_server.username, cfg_server.realname,
-                     cfg_server.hostname, cfg_server.command,
-                     cfg_server.command_delay, cfg_server.autojoin,
-                     cfg_server.autorejoin, cfg_server.notify_levels))
+    if (!server_clone (&cfg_server))
     {
         server_free_all ();
         gui_printf (NULL,
@@ -1845,6 +1823,117 @@ config_default_values ()
 }
 
 /*
+ * returns dynamicly allocated nickname
+ */
+static char*
+get_default_nick()
+{
+    struct passwd *my_passwd;
+
+    if ((my_passwd = getpwuid(geteuid ())) != NULL)
+        return strdup(my_passwd->pw_name);
+    weechat_iconv_fprintf (stderr, "%s: %s (%s).",
+            WEECHAT_WARNING,
+            _("unable to get user's name"),
+            strerror(errno));
+    return strdup("weechat");
+}
+
+/*
+ * returns dynamicly allocated realname
+ */
+static char*
+get_default_realname() 
+{
+    struct passwd *my_passwd;
+    char *realname, *pos;
+
+    if ((my_passwd = getpwuid (geteuid ())) != NULL) {
+        if ((!my_passwd->pw_gecos)
+            || (my_passwd->pw_gecos[0] == '\0')
+            || (my_passwd->pw_gecos[0] == ',')
+            || (my_passwd->pw_gecos[0] == ' ')
+        ) {
+            return strdup(my_passwd->pw_name);
+        }
+        else
+        {
+            realname = strdup (my_passwd->pw_gecos);
+            pos = strchr (realname, ',');
+            if (pos)
+                pos[0] = '\0';
+            return realname;
+        }
+    }
+    else {
+        weechat_iconv_fprintf (stderr, "%s: %s (%s).",
+                WEECHAT_WARNING,
+                _("unable to get user's name"),
+                strerror(errno));
+        return strdup("WeeChat default realname");
+    }
+}
+
+/*
+ * initialize "server_defaults" section
+ */
+static void
+config_init_server_defaults() 
+{
+    t_config_option *p, *q, *new;
+    char *nickname, *realname;
+
+    if (weechat_options_server_defaults != NULL)
+        return; /* it's already initialized */
+
+    for (p = weechat_options_server; p->option_name; p++)
+        if (p->offsetof_isset > 0) /* we've found defaultable option! */
+            break;
+    if (!p->option_name )
+        return;
+    for (q = p; q->option_name; q++)
+        ; /* no-op */
+    q++;
+
+    new = calloc(q - p, sizeof(t_config_option));
+
+    /* nickname, realname will be stolen and will not be free()-d */
+    nickname = get_default_nick();
+    realname = get_default_realname();
+    
+    memcpy(new, p, (q - p) * sizeof(t_config_option));
+    for (p = new; p->option_name; p++) {
+        /* some sort of ugly hack */
+        if (p->ptr_string)
+            p->ptr_string = (char**)((unsigned long)p->ptr_string - (unsigned long)&cfg_server + (unsigned long)&server_defaults);
+        if (p->ptr_int)
+            p->ptr_int = (int*)((unsigned long)p->ptr_int - (unsigned long)&cfg_server + (unsigned long)&server_defaults);
+
+        p->handler_change = config_change_noop;
+
+        if (strcmp(p->option_name, "server_nick1") == 0)
+            p->default_string = nickname; /* stolen here */
+        else if (strcmp(p->option_name, "server_nick2") == 0) {
+            p->default_string = calloc(strlen(nickname) + 2, sizeof(char));
+            strcpy(p->default_string, nickname);
+            strcat(p->default_string, "1");
+        }
+        else if (strcmp(p->option_name, "server_nick3") == 0) {
+            p->default_string = calloc(strlen(nickname) + 2, sizeof(char));
+            strcpy(p->default_string, nickname);
+            strcat(p->default_string, "2");
+        }
+        else if (strcmp(p->option_name, "server_username") == 0)
+            p->default_string = strdup(nickname);
+        else if (strcmp(p->option_name, "server_realname") == 0)
+            p->default_string = realname; /* stolen here */
+    }
+
+    weechat_options_server_defaults = new;
+    weechat_options[CONFIG_SECTION_SERVER_DEFAULTS] = new;
+}
+
+/*
  * config_read: read WeeChat configuration
  *              returns:   0 = successful
  *                        -1 = config file file not found
@@ -1861,6 +1950,8 @@ config_read ()
     int server_found;
     char line[1024], *ptr_line, *ptr_line2, *pos, *pos2;
 
+    config_init_server_defaults();
+
     filename_length = strlen (weechat_home) + strlen (WEECHAT_CONFIG_NAME) + 2;
     filename = (char *) malloc (filename_length * sizeof (char));
     if (!filename)
@@ -1875,6 +1966,7 @@ config_read ()
         return -1;
     }
     
+    server_init (&server_defaults);
     config_default_values ();
     server_init (&cfg_server);
     
@@ -2125,7 +2217,7 @@ config_read ()
             return -2;
         }
     }
-    
+
     fclose (file);
     free (filename);
     
@@ -2147,8 +2239,6 @@ config_create_default ()
     FILE *file;
     int i, j;
     time_t current_time;
-    struct passwd *my_passwd;
-    char *realname, *pos;
     t_gui_key *ptr_key;
     char *expanded_name, *function_name;
 
@@ -2271,59 +2361,11 @@ config_create_default ()
     /* default server is freenode */
     weechat_iconv_fprintf (file, "\n[server]\n");
     weechat_iconv_fprintf (file, "server_name = \"freenode\"\n");
-    weechat_iconv_fprintf (file, "server_autoconnect = on\n");
-    weechat_iconv_fprintf (file, "server_autoreconnect = on\n");
-    weechat_iconv_fprintf (file, "server_autoreconnect_delay = 30\n");
     weechat_iconv_fprintf (file, "server_address = \"irc.freenode.net\"\n");
     weechat_iconv_fprintf (file, "server_port = 6667\n");
-    weechat_iconv_fprintf (file, "server_ipv6 = off\n");
-    weechat_iconv_fprintf (file, "server_ssl = off\n");
     weechat_iconv_fprintf (file, "server_password = \"\"\n");
-    
-    /* Get the user's name from /etc/passwd */
-    if ((my_passwd = getpwuid (geteuid ())) != NULL)
-    {
-        weechat_iconv_fprintf (file, "server_nick1 = \"%s\"\n", my_passwd->pw_name);
-        weechat_iconv_fprintf (file, "server_nick2 = \"%s1\"\n", my_passwd->pw_name);
-        weechat_iconv_fprintf (file, "server_nick3 = \"%s2\"\n", my_passwd->pw_name);
-        weechat_iconv_fprintf (file, "server_username = \"%s\"\n", my_passwd->pw_name);
-        if ((!my_passwd->pw_gecos)
-            || (my_passwd->pw_gecos[0] == '\0')
-            || (my_passwd->pw_gecos[0] == ',')
-            || (my_passwd->pw_gecos[0] == ' '))
-            weechat_iconv_fprintf (file, "server_realname = \"%s\"\n", my_passwd->pw_name);
-        else
-        {
-            realname = strdup (my_passwd->pw_gecos);
-            pos = strchr (realname, ',');
-            if (pos)
-                pos[0] = '\0';
-            weechat_iconv_fprintf (file, "server_realname = \"%s\"\n",
-                                   realname);
-            if (pos)
-                pos[0] = ',';
-            free (realname);
-        }
-    }
-    else
-    {
-        /* default values if /etc/passwd can't be read */
-        weechat_iconv_fprintf (stderr, "%s: %s (%s).",
-                               WEECHAT_WARNING,
-                               _("Unable to get user's name"),
-                               strerror (errno));
-        weechat_iconv_fprintf (file, "server_nick1 = \"weechat1\"\n");
-        weechat_iconv_fprintf (file, "server_nick2 = \"weechat2\"\n");
-        weechat_iconv_fprintf (file, "server_nick3 = \"weechat3\"\n");
-        weechat_iconv_fprintf (file, "server_username = \"weechat\"\n");
-        weechat_iconv_fprintf (file, "server_realname = \"WeeChat default realname\"\n");
-    }
-    
-    weechat_iconv_fprintf (file, "server_hostname = \"\"\n");
     weechat_iconv_fprintf (file, "server_command = \"\"\n");
-    weechat_iconv_fprintf (file, "server_command_delay = 0\n");
     weechat_iconv_fprintf (file, "server_autojoin = \"\"\n");
-    weechat_iconv_fprintf (file, "server_autorejoin = on\n");
     weechat_iconv_fprintf (file, "server_notify_levels = \"\"\n");
     
     fclose (file);
